'''
Authors: Autumn Harrison & Jayden Davis
Date: 2023-11-07
Course: CSCI 2910 
Document Name: CookingTips.py

Contains all 50+ cooking tips that can be randomly chosen.

'''

cooking_tips = [
    "Remember, y’all, it’s all about the prep. Take away the stress by doing the prep the night or day before. You’ll look like a star. - Paula Deen",
    "The smaller the item, the higher the baking temperature. For example, I bake mini chocolate chip-toffee cookies at 500 degrees F for only 4 minutes. Perfect end result. - Jim Lahey",
    "Store spices in a cool, dark place, not above your stove. Humidity, light and heat will cause herbs and spices to lose their flavor. - Rick Tramonto",
    "Use a coarse microplane to shave vegetables into salads or vinaigrettes. You can create an orange-fennel dressing by adding grated fennel and orange zest to a simple vinaigrette. - Paul Kahan",
    "Always make stock in a large quantity and freeze it in plastic bags. That way, when you want to make a nice soup or boil veggies, you can simply pull the bag out of the freezer. - Charlie Trotter",
    "If you’re cooking for someone important — whether it’s your boss or a date — never try a new recipe and a new ingredient at the same time. - Marcus Samuelsson",
    "Cook pasta 1 minute less than the package instructions and cook it the rest of the way in the pan with sauce. - Mario Batali",
    "After making eggs sunny-side up, deglaze the pan with sherry vinegar, then drizzle the sauce on the eggs to add another dimension to the dish. - Didier Elena",
    "Brine, baby, brine! Ya gotta brine that poultry to really give it the super flavor. - Guy Fieri",
    "If you find you need more oil in the pan when sautéing, add it in a stream along the edges of the pan so that by the time the oil reaches the ingredient being cooked, it will be heated. - Anita Lo"
    "For rich, creamy dressings made healthy, substitute half the mayo with Greek-style yogurt. - Ellie Krieger",
    "When chopping herbs, toss a little salt onto the cutting board; it will keep the herbs from flying around. - Joanne Chang",
    "For best results when you’re baking, leave butter and eggs at room temperature overnight. - Barefoot Contessa",
    "Homemade vinaigrettes have fewer ingredients and taste better than bottled ones. No need to whisk them: Just put all the ingredients in a sealed container and shake. - Bill Telepan",
    "For an easy weeknight meal, save and freeze leftover sauces from previous meals in ice cube trays. The cubes can be reheated in a sauté pan when you need a quick sauce. - David Burke",
    "When making meatballs or meatloaf, you need to know how the mixture tastes before you cook it. Make a little patty and fry it in a pan like a mini hamburger. Then you can taste it and adjust the seasoning. - Isaac Becker",
    "Low and slow. - Pat Neely",
    "Acidity, salt and horseradish bring out full flavors in food. - Michael Symon",
    "Taste as you go! - Anne Burrell",
    "Do not use oil in the water when boiling pasta: It will keep the sauce from sticking to the cooked pasta. - Missy Robbins",
    "When you’re going to sauté garlic, slice it rather than mincing it — it’s less likely to burn that way. - Aarti Sequeira",
    "When you’re browning meat, you should blot the surface dry with a paper towel so the meat doesn’t release moisture when it hits the hot oil. Too much moisture makes the meat steam instead of sear, and you will lose that rich brown crust. - Charlie Palmer",
    "A cast-iron pan is a valuable kitchen ally. It offers an even cooking surface and is a breeze to clean. - Linton Hopkins",
    "Invest in a bottle of high-quality olive oil. Just a small drizzle can really bring out the flavor of pizza, mozzarella, pasta, fish and meat. - Nancy Silverton",
    "When seasoning a salad, use coarse sea salt mixed with a little olive oil. It will stay crunchy when combined with the vinaigrette. - Paul Liebrandt",
    "Always use sharp knives. Not only is it safer but it will make your work much more efficient. - April Bloomfield",
    "Rest, rest, rest! Always let your meat rest — especially off a hot grill! - Melissa d'Arabian",
    "Plunge vegetables in ice water after blanching (boiling) them so they maintain a bright color. - Maria Hines",
    "Invest in parchment paper for lining pans. It makes all of your baked goods super easy to remove, and it makes cleanup a dream (no butter-flour mixture or errant batter to scrape off). - Matt Lewis",
    "My grandfather taught me this tip: After you drain pasta, while it’s still hot, grate some fresh Parmesan on top before tossing it with your sauce. This way, the sauce has something to stick to. - Giada De Laurentiis",
    "Don’t overcrowd the pan when you’re sautéing — it’ll make your food steam instead. - Ryan Poli",
    "Buy fruit at its peak at a farmers’ market and freeze it in an airtight container so you can enjoy it year round. - Mindy Segal",
    "Season all of your food from start to finish. Seasoning in stages brings the most out of your ingredients and gives you the most flavor. - Jose Garces",
    "When grinding your own beef for burgers, grind in some bacon. - Sean Brock",
    "When making mashed potatoes, after you drain the potatoes, return them to the hot pan, cover tightly and let steam for 5 minutes. This allows the potatoes to dry out so they’ll mash to a beautiful texture and soak up the butter and cream more easily. - Wolfgang Puck",
    "If you want to make a proper Louisiana-style roux that’s chocolate in color and rich in flavor, remember slow and low is the way to go. - Emeril Lagasse",
    "When you grill, pull your steaks out of the refrigerator one hour ahead of time so they can come to room temperature. - Geoffrey Zakarian",
    "Always measure what you’re baking. No shortcuts in pastry: It’s a science. - Francois Payard",
    "If you don’t have time to brine your chicken, use this simple trick: Heavily salt the chicken (inside and out) about an hour before you cook it. Then pat it dry and roast. This ensures crispy skin and juicy meat. - David Myers",
    "For perfect vegetable soup, start with diced carrots, onions, peppers and tomatoes sautéed in oil or butter before you add any liquid. This brings out the taste and caramelizes the sugars. - Shaun Hergatt",
    "Clean as you go. (Dorky, but I swear it really helps.) - Rick Bayless",
    "Always buy the freshest garlic you can find; the fresher it is, the sweeter it will be. The best garlic has firm tissue-like skin and should not be bruised, sprouted, soft or shriveled. If you find cloves that have green shoots, discard the shoots — they will only add bitterness. - Todd English",
    "Keep flavored vinegars near the stove so you won’t always reach for the salt. Acid enhances flavor. - Art Smith", 
    "Don’t be too hard on yourself — mistakes make some of the best recipes! Keep it simple. - Sunny Anderson",
    "Want to know if your oil is hot enough for frying? Here’s a tip: Stick a wooden skewer or spoon in the oil. If bubbles form around the wood, then you are good to go. - Aaron McCargo, Jr.",
    "Make sure the handle of your sauté pan is turned away from you so you don’t hit it and knock it off the stove. It happens all the time. - Jonathan Waxman",
    "Caramelize onions very quickly by cooking them in a dry nonstick sauté pan over medium-high heat. They will caramelize beautifully in a lot less time than with traditional methods. - Michael Mina",
    "Whenever you cook pasta, remove some of the pasta-cooking water (about 1/4 or 1/3 cup) just before draining. When you add the sauce of your choice to the pasta, add a little of the cooking liquid. This helps sauce to amalgamate; the starch in the water adds body and a kind of creaminess. An old Italian friend of mine instructed me in this finishing touch early on, and I would never, ever leave it out. It makes all the difference. - Nigella Lawson",
    "When making caramel, use a nonstick pot. That way, when you pour the mixture out, there is no waste, and cleaning the pot is a breeze. - Jehangir Mehta",
    "Always start with a smokin’ hot pan! - Cat Cora",
    "When baking cookies, be sure your dough is thoroughly chilled when it goes on your baking pan. This will allow the leavening ingredients to work before the butter flattens out and your cookies lose their textural distinctions. - Norman Van Aken"
    
]
